import { watch } from 'fs';
import { promises } from 'fs';
import { ContentFile, createContentReferrer, getContentRefererConstructor } from '../content/referrer'
import path from 'path';

const readdir = promises.readdir;


export class Watcher{
    private _type: string;
    private _path:string;
    /**
     * @todo : alter type Map<string,ContentReferrer>
    */
    private _added: ContentFile[];
    private _deleted: ContentFile[];
    constructor(path:string,type:string){
        this._path = path;
        this._added =[];
        this._deleted =[];
        this._type = type;
    }
    public get added() : ContentFile[] {
        return this._added;
    }
    /*public set added(diff : FileDiff[]) {
        this._added = diff;
    }*/
    public get deleted(): ContentFile[]{
        return this._deleted;
    }
    /*public set deleted(diff : FileDiff[]){
        this._deleted = diff;
    }*/
    public get path(){
        return this._path;
    }
    public get type(){
        return this._type;
    }
    private createCR(filename: string){
        return createContentReferrer(`${this.path}/${filename}`,this.type);
    }
    /**
     * 
     */
    async setup(initial_filenames:string[]){
        const cur = (await readdir(this._path,{
            encoding:"utf8",
            withFileTypes: true,
        })).filter(x=>x.isFile).map(x=>x.name);
        let added = cur.filter(x => !initial_filenames.includes(x));
        let deleted = initial_filenames.filter(x=>!cur.includes(x));
        this._added = added.map(x=>this.createCR(x));
        this._deleted = deleted.map(x=>this.createCR(x));
        watch(this._path,{persistent: true, recursive:false},async (eventType,filename)=>{
            if(eventType === "rename"){
                const cur = (await readdir(this._path,{
                    encoding:"utf8",
                    withFileTypes: true,
                })).filter(x=>x.isFile).map(x=>x.name);
                //add
                if(cur.includes(filename)){
                    this._added.push(this.createCR(filename));
                }
                else{
                    //added has one
                    if(this._added.map(x=>x.path).includes(path.join(this.path,filename))){
                        this._added = this._added.filter(x=> x.path !== path.join(this.path,filename));
                    }
                    else {
                        this._deleted.push(this.createCR(filename));
                    }
                }
            }
        });
    }
}

export class DiffWatcher{
    Watchers: {[basepath:string]:Watcher} = {};
}